﻿#region license
// Copyright (c) 2003, 2004, Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 11/8/2004 10:10:57
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class ArrayTypeReferenceImpl : TypeReference
	{

		protected TypeReference _elementType;

		protected ArrayTypeReferenceImpl()
		{
			InitializeFields();
		}
		
		protected ArrayTypeReferenceImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected ArrayTypeReferenceImpl(TypeReference elementType)
		{
			InitializeFields();
			ElementType = elementType;
		}
			
		protected ArrayTypeReferenceImpl(LexicalInfo lexicalInfo, TypeReference elementType) : base(lexicalInfo)
		{
			InitializeFields();
			ElementType = elementType;
		}
			
		new public ArrayTypeReference CloneNode()
		{
			return Clone() as ArrayTypeReference;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.ArrayTypeReference;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_elementType == existing)
			{
				this.ElementType = (TypeReference)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			ArrayTypeReference clone = FormatterServices.GetUninitializedObject(typeof(ArrayTypeReference)) as ArrayTypeReference;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			if (null != _elementType)
			{
				clone._elementType = _elementType.Clone() as TypeReference;
				clone._elementType.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public TypeReference ElementType
		{
			get
			{
				return _elementType;
			}
			

			set
			{
				if (_elementType != value)
				{
					_elementType = value;
					if (null != _elementType)
					{
						_elementType.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

		}
	}
}
