﻿#region license
// Copyright (c) 2003, 2004, Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 11/8/2004 10:10:57
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class SlicingExpressionImpl : Expression
	{

		protected Expression _target;
		protected Expression _begin;
		protected Expression _end;
		protected Expression _step;

		protected SlicingExpressionImpl()
		{
			InitializeFields();
		}
		
		protected SlicingExpressionImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected SlicingExpressionImpl(Expression target, Expression begin, Expression end, Expression step)
		{
			InitializeFields();
			Target = target;
			Begin = begin;
			End = end;
			Step = step;
		}
			
		protected SlicingExpressionImpl(LexicalInfo lexicalInfo, Expression target, Expression begin, Expression end, Expression step) : base(lexicalInfo)
		{
			InitializeFields();
			Target = target;
			Begin = begin;
			End = end;
			Step = step;
		}
			
		new public SlicingExpression CloneNode()
		{
			return Clone() as SlicingExpression;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.SlicingExpression;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_target == existing)
			{
				this.Target = (Expression)newNode;
				return true;
			}

			if (_begin == existing)
			{
				this.Begin = (Expression)newNode;
				return true;
			}

			if (_end == existing)
			{
				this.End = (Expression)newNode;
				return true;
			}

			if (_step == existing)
			{
				this.Step = (Expression)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			SlicingExpression clone = FormatterServices.GetUninitializedObject(typeof(SlicingExpression)) as SlicingExpression;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			clone._expressionType = _expressionType;
			

			if (null != _target)
			{
				clone._target = _target.Clone() as Expression;
				clone._target.InitializeParent(clone);
			}

			if (null != _begin)
			{
				clone._begin = _begin.Clone() as Expression;
				clone._begin.InitializeParent(clone);
			}

			if (null != _end)
			{
				clone._end = _end.Clone() as Expression;
				clone._end.InitializeParent(clone);
			}

			if (null != _step)
			{
				clone._step = _step.Clone() as Expression;
				clone._step.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public Expression Target
		{
			get
			{
				return _target;
			}
			

			set
			{
				if (_target != value)
				{
					_target = value;
					if (null != _target)
					{
						_target.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Begin
		{
			get
			{
				return _begin;
			}
			

			set
			{
				if (_begin != value)
				{
					_begin = value;
					if (null != _begin)
					{
						_begin.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression End
		{
			get
			{
				return _end;
			}
			

			set
			{
				if (_end != value)
				{
					_end = value;
					if (null != _end)
					{
						_end.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Step
		{
			get
			{
				return _step;
			}
			

			set
			{
				if (_step != value)
				{
					_step = value;
					if (null != _step)
					{
						_step.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

		}
	}
}
