
namespace BooCompiler.Tests
{
	using NUnit.Framework;
	using Boo.Lang.Compiler;	

	[TestFixture]
	public class CompilerErrorsTestFixture : AbstractCompilerTestCase
	{	
		protected override CompilerPipeline SetUpCompilerPipeline()
		{
			CompilerPipeline pipeline = new Boo.Lang.Compiler.Pipelines.Compile();
			pipeline.Add(new Boo.Lang.Compiler.Steps.PrintErrors());
			return pipeline;
		}
		
		protected override bool IgnoreErrors
		{
			get
			{
				return true;
			}
		}

		[Test]
		public void BCE0005_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0005-1.boo");
		}
		
		[Test]
		public void BCE0006_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0006-1.boo");
		}
		
		[Test]
		public void BCE0017_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0017-1.boo");
		}
		
		[Test]
		public void BCE0017_2()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0017-2.boo");
		}
		
		[Test]
		public void BCE0020_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0020-1.boo");
		}
		
		[Test]
		public void BCE0022_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0022-1.boo");
		}
		
		[Test]
		public void BCE0022_2()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0022-2.boo");
		}
		
		[Test]
		public void BCE0022_3()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0022-3.boo");
		}
		
		[Test]
		public void BCE0022_4()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0022-4.boo");
		}
		
		[Test]
		public void BCE0023_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0023-1.boo");
		}
		
		[Test]
		public void BCE0024_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0024-1.boo");
		}
		
		[Test]
		public void BCE0032_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0032-1.boo");
		}
		
		[Test]
		public void BCE0046_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0046-1.boo");
		}
		
		[Test]
		public void BCE0047_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0047-1.boo");
		}
		
		[Test]
		public void BCE0049_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0049-1.boo");
		}
		
		[Test]
		public void BCE0053_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0053-1.boo");
		}
		
		[Test]
		public void BCE0053_2()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0053-2.boo");
		}
		
		[Test]
		public void BCE0054_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0054-1.boo");
		}
		
		[Test]
		public void BCE0057_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0057-1.boo");
		}
		
		[Test]
		public void BCE0060_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0060-1.boo");
		}
		
		[Test]
		public void BCE0063_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0063-1.boo");
		}
		
		[Test]
		public void BCE0063_2()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0063-2.boo");
		}
		
		[Test]
		public void BCE0065_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0065-1.boo");
		}
		
		[Test]
		public void BCE0067_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0067-1.boo");
		}
		
		[Test]
		public void BCE0067_2()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0067-2.boo");
		}
		
		[Test]
		public void BCE0067_3()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0067-3.boo");
		}
		
		[Test]
		public void BCE0070_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0070-1.boo");
		}
		
		[Test]
		public void BCE0071_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0071-1.boo");
		}
		
		[Test]
		public void BCE0071_2()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0071-2.boo");
		}
		
		[Test]
		public void BCE0072_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0072-1.boo");
		}
		
		[Test]
		public void BCE0073_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0073-1.boo");
		}
		
		[Test]
		public void BCE0079_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0079-1.boo");
		}
		
		[Test]
		public void BCE0080_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0080-1.boo");
		}
		
		[Test]
		public void BCE0081_1()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0081-1.boo");
		}
		
		[Test]
		public void BCE0081_2()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0081-2.boo");
		}
		
		[Test]
		public void BCE0081_3()
		{
			RunCompilerTestCase(@"d:\dev\boo\tests\testcases\errors\BCE0081-3.boo");
		}
		
	}
}
